﻿Public Class RtbCtrl
    Private Sub UpdateNumberLabel()
        Dim pos As New Point(0, 0)
        Dim firstIndex As Integer = rtb.GetCharIndexFromPosition(pos)
        Dim firstLine As Integer = rtb.GetLineFromCharIndex(firstIndex)

        pos.X = Me.ClientRectangle.Width
        pos.Y = Me.ClientRectangle.Height
        Dim lastIndex As Integer = rtb.GetCharIndexFromPosition(pos)
        Dim lastLine As Integer = rtb.GetLineFromCharIndex(lastIndex)

        pos = rtb.GetPositionFromCharIndex(lastIndex)

        lbLineNumbers.Text = ""
        For i As Integer = firstLine To lastLine + 1
            lbLineNumbers.Text += i + 1 & vbCrLf
        Next
    End Sub

    Private Sub rtb_FontChanged(sender As Object, e As System.EventArgs) Handles rtb.FontChanged
        UpdateNumberLabel()
    End Sub

    Private Sub rtb_SizeChanged(sender As Object, e As System.EventArgs) Handles rtb.SizeChanged
        UpdateNumberLabel()
    End Sub

    Private Sub rtb_TextChanged(sender As Object, e As System.EventArgs) Handles rtb.TextChanged
        UpdateNumberLabel()
    End Sub

    Private Sub rtb_VScroll(sender As Object, e As System.EventArgs) Handles rtb.VScroll

        Dim d As Integer = rtb.GetPositionFromCharIndex(0).Y Mod (rtb.Font.Height)
        lbLineNumbers.Location = New Point(0, d + 2)

        UpdateNumberLabel()
    End Sub

End Class
